routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
        return view('welcome');
    })->name('welcome');

Auth::routes();

Route::get('/preferences/{preference}', 'PreferencesController@show')->name('preferences.show');
Route::get('/preferences/{preference}/edit', 'PreferencesController@edit')->name('preferences.edit');
Route::patch('/preferences/{preference}', 'PreferencesController@update')->name('preferences.update');

Route::resource(	'jobs/{job}/materials',
					'JobMaterialsController',
					['names' => [
    						'index' => 'jobs.materials.index',
    						'create' => 'jobs.materials.create',
    						'store' => 'jobs.materials.store',
    						'show' => 'jobs.materials.show',
    						'edit' => 'jobs.materials.edit',
    						'update' => 'jobs.materials.update',
    						'destroy' => 'jobs.materials.destroy',
						]
					]);

Route::resource(	'jobs/{job}/labour',
					'JobLabourController',
					['names' => [
    						'index' => 'jobs.labour.index',
    						'create' => 'jobs.labour.create',
    						'store' => 'jobs.labour.store',
    						'show' => 'jobs.labour.show',
    						'edit' => 'jobs.labour.edit',
    						'update' => 'jobs.labour.update',
    						'destroy' => 'jobs.labour.destroy',
						]
					]);

Route::post('jobs/{job}/invoices/{invoice}/toggle-send', 'JobInvoicesController@toggleSend')->name('jobs.invoices.toggleSend');
Route::get('jobs/{job}/invoices/{invoice}/send/{details}', 'JobInvoicesController@send')->name('jobs.invoices.send');

Route::get('jobs/{job}/invoices/{invoice}/toggle-pay', 'JobInvoicesController@togglePay')->name('jobs.invoices.togglePay');

Route::get('jobs/{job}/invoices/{invoice}/print', 'JobInvoicesController@print')->name('jobs.invoices.print');
Route::post('jobs/{job}/invoices/{invoice}/print', 'JobInvoicesController@print')->name('jobs.invoices.print');

Route::resource(	'jobs/{job}/invoices',
					'JobInvoicesController',
					['names' => [
    						'index' => 'jobs.invoices.index',
    						'create' => 'jobs.invoices.create',
    						'store' => 'jobs.invoices.store',
    						'show' => 'jobs.invoices.show',
    						'edit' => 'jobs.invoices.edit',
    						'update' => 'jobs.invoices.update',
    						'destroy' => 'jobs.invoices.destroy',
						]
					]);

Route::resource(	'jobs/{job}/invoices/{invoice}/materials',
					'JobInvoicesMaterialsController',
					['names' => [
    						'index' => 'jobs.invoices.materials.index',
    						'create' => 'jobs.invoices.materials.create',
    						'store' => 'jobs.invoices.materials.store',
    						'show' => 'jobs.invoices.materials.show',
    						'edit' => 'jobs.invoices.materials.edit',
    						'update' => 'jobs.invoices.materials.update',
    						'destroy' => 'jobs.invoices.materials.destroy',
						]
					]);

Route::resource(	'jobs/{job}/invoices/{invoice}/labour',
					'JobInvoicesLabourController',
					['names' => [
    						'index' => 'jobs.invoices.labour.index',
    						'create' => 'jobs.invoices.labour.create',
    						'store' => 'jobs.invoices.labour.store',
    						'show' => 'jobs.invoices.labour.show',
    						'edit' => 'jobs.invoices.labour.edit',
    						'update' => 'jobs.invoices.labour.update',
    						'destroy' => 'jobs.invoices.labour.destroy',
						]
					]);

Route::post('jobs/{job}/proposals/{proposal}/toggle-send', 'JobProposalsController@toggleSend')->name('jobs.proposals.toggleSend');
Route::post('jobs/{job}/proposals/{proposal}/send', 'JobProposalsController@send')->name('jobs.proposals.send');
Route::get('jobs/{job}/proposals/{proposal}/change-status/{status}', 'JobProposalsController@changeStatus')->name('jobs.proposals.changeStatus');

Route::get('jobs/{job}/proposals/{proposal}/print', 'JobProposalsController@print')->name('jobs.proposals.print');

Route::resource(    'jobs/{job}/proposals/{proposal}/scopes',
                    'JobProposalsScopesController',
                    ['names' => [
                            'index' => 'jobs.proposals.scopes.index',
                            'create' => 'jobs.proposals.scopes.create',
                            'store' => 'jobs.proposals.scopes.store',
                            'show' => 'jobs.proposals.scopes.show',
                            'edit' => 'jobs.proposals.scopes.edit',
                            'update' => 'jobs.proposals.scopes.update',
                            'destroy' => 'jobs.proposals.scopes.destroy',
                        ]
                    ]);

Route::resource(	'jobs/{job}/proposals',
					'JobProposalsController',
					['names' => [
    						'index' => 'jobs.proposals.index',
    						'create' => 'jobs.proposals.create',
    						'store' => 'jobs.proposals.store',
    						'show' => 'jobs.proposals.show',
    						'edit' => 'jobs.proposals.edit',
    						'update' => 'jobs.proposals.update',
    						'destroy' => 'jobs.proposals.destroy',
						]
					]);

Route::resource(	'jobs/{job}/proposals/{proposal}/materials',
					'JobProposalsMaterialsController',
					['names' => [
    						'index' => 'jobs.proposals.materials.index',
    						'create' => 'jobs.proposals.materials.create',
    						'store' => 'jobs.proposals.materials.store',
    						'show' => 'jobs.proposals.materials.show',
    						'edit' => 'jobs.proposals.materials.edit',
    						'update' => 'jobs.proposals.materials.update',
    						'destroy' => 'jobs.proposals.materials.destroy',
						]
					]);

Route::resource(	'jobs/{job}/proposals/{proposal}/labour',
					'JobProposalsLabourController',
					['names' => [
    						'index' => 'jobs.proposals.labour.index',
    						'create' => 'jobs.proposals.labour.create',
    						'store' => 'jobs.proposals.labour.store',
    						'show' => 'jobs.proposals.labour.show',
    						'edit' => 'jobs.proposals.labour.edit',
    						'update' => 'jobs.proposals.labour.update',
    						'destroy' => 'jobs.proposals.labour.destroy',
						]
					]);

Route::resource('/jobs', 'JobController');

Route::view('/calculator', 'calculator')->name('calculator');

Route::get('/home', 'HomeController@index')->name('home');

/*
ACTIONS HANDLED BY RESOURCE CONTROLLER
VERB		URI						ACTION		ROUTE NAME
GET			/photos					index		photos.index
GET			/photos/create			create		photos.create
POST		/photos					store		photos.store
GET			/photos/{photo}			show		photos.show
GET			/photos/{photo}/edit	edit		photos.edit
PUT/PATCH	/photos/{photo}			update		photos.update
DELETE		/photos/{photo}			destroy		photos.destroy
*/

app/Job.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Job extends Model
{
	/*
	$table->string('number')->unique();
	$table->string('name');
	$table->string('address')->nullable();
	$table->bigInteger('phone')->nullable()->unsigned();
	$table->string('email')->nullable();
	$table->string('extension')->nullable();
	$table->text('note')->nullable();
	$table->boolean('finished')->default(0);
	*/

	protected $fillable = [
		'number',
		'name',
		'address',
		'phone',
		'email',
		'extension',
		'note',
		'finished',
		'deadline'
	];

	protected $dates = [
		'created_at',
		'updated_at',
		'finished',
		'deadline',
	];

	public function materials()
	{
		return $this->morphMany('App\Materials', 'materialable');
	}

	public function labour()
	{
		return $this->morphMany('App\Labour', 'labourable');
	}

	public function invoices()
	{
		return $this->hasMany( Invoices::class );
	}

	public function proposals()
	{
		return $this->hasMany( Proposals::class );
	}

	//
	public function scopeUnfinished( $query )
	{
		return $query->where('finished', '=', null);
	}

	public function scopeFinished( $query )
	{
		return $query->where('finished', '!=', null);
	}

	public function setPhoneAttribute( $value )
	{
		$phone = preg_replace("/[^0-9]/","", $value);
		$this->attributes['phone'] = ( empty( $phone ) ? null : $phone );
	}

	public Function setNameAttribute( $value )
	{
		$this->attributes['name'] = ucwords( $value );
	}

	public function setDeadlineAttribute( $value )
	{
		$this->attributes['deadline'] = $value;

		if ( $value !== null )
		{
			$this->attributes['deadline'] = date( 'Y-m-d 23:59:59', strtotime($value) );
		}
	}

	public function isLate()
	{
		return ( $this->deadline !== null && $this->finished === null && $this->deadline->isPast()) ? true : false;
	}

	public function toggleFinished()
	{
		$this->finished = !$this->finished;

		return $this;
	}
		/**
	 * Formats US and CA phone number formats
	 * @param  STRING $value Phone Number of Variable Length
	 * @return STRING        Phone number in pleasant visual format
	 */
	public function formatPhoneNumber( $value = null )
	{
		$value = ( is_null( $value ) ) ? $value = $this->attributes['phone'] : $value;

		$length = strlen($value);
		switch($length)
		{
			case 7:
				return preg_replace("/([0-9]{3})([0-9]{4})/", "$1-$2", $value);
				break;
			case 10:
				return preg_replace("/([0-9]{3})([0-9]{3})([0-9]{4})/", "$1-$2-$3", $value);
			break;
			case 11:
				return preg_replace("/([0-9]{1})([0-9]{3})([0-9]{3})([0-9]{4})/", "$1-$2-$3-$4", $value);
			break;
			default:
				return $value;
			break;
		}
	}

}

app/Http/Controllers/JobController.php
<?php

namespace App\Http\Controllers;

use App\Job;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;

class JobController extends Controller
{
	/**
	 * Display a listing of the resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function index()
	{
		//
		$jobs = Job::orderBy('created_at', 'DESC')->with(['materials', 'labour'])->get();

		return view('jobs.index', compact('jobs'));
	}

	/**
	 * Show the form for creating a new resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function create()
	{
		//
		return view('jobs.create');
	}

	/**
	 * Store a newly created resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function store(Request $request)
	{
		$request->validate([
			'name' => 'nullable|min:2|max:50',
			'email' => 'nullable|email',
			'address' => 'required|min:2',
			'phone' => 'nullable|min:10|max:15',
			'note' =>	'nullable|min:2',
			'deadline' => 'nullable|date'
		]);
		//
		$job =Job::create(
			[
				'number' => $this->createJobNumber(),
				'name' => $request->name,
				'address' => $request->address,
				'phone' => $request->phone,
				'extension' => $request->extension,
				'email' => $request->email,
				'note' => $request->note,
				'deadline' => ( $request->deadline !== null ) ? $request->deadline : null,
			]
		);

		$request->session()->flash('success', 'Successfully created new Job.');

		return redirect( route( 'jobs.show', $job->id ) );
	}

	/**
	 * Display the specified resource.
	 *
	 * @param  \App\Job  $job
	 * @return \Illuminate\Http\Response
	 */
	public function show($job)
	{
		$job = Job::where( 'id', '=', $job )->
					with(
						'materials',
						'labour',
						'invoices.materials',
						'invoices.labour',
						'proposals.materials',
						'proposals.labour'
					)->first();

		return view('jobs.show', compact('job'));
	}

	/**
	 * Show the form for editing the specified resource.
	 *
	 * @param  \App\Job  $job
	 * @return \Illuminate\Http\Response
	 */
	public function edit(Job $job)
	{
		//
		return view('jobs.edit', compact('job'));
	}

	/**
	 * Update the specified resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @param  \App\Job  $job
	 * @return \Illuminate\Http\Response
	 */
	public function update(Request $request, Job $job)
	{
		//
		$request->validate([
			'name' => 'nullable|min:2|max:50',
			'email' => 'nullable|email',
			'address' => 'required|min:2',
			'phone' => 'nullable|min:10|max:15',
			'note' =>	'nullable|min:2',
			'deadline' => 'nullable|date',
		]);

		$job->name = $request->name;
		$job->email = $request->email;
		$job->address = $request->address;
		$job->phone = $request->phone;
		$job->extension = $request->extension;
		$job->note = $request->note;
		$job->deadline = ( $request->deadline !== null ) ? $request->deadline : null;

		$job->save();

		$request->session()->flash('success', "Successfully updated Job.");

		return redirect( route( 'jobs.show', $job->id ) );
	}

	/**
	 * Remove the specified resource from storage.
	 *
	 * @param  \App\Job  $job
	 * @return \Illuminate\Http\Response
	 */
	public function destroy(Job $job)
	{
		//
		foreach( $job->invoices as $invoice )
        {
            $invoice->materials()->delete();
            $invoice->labour()->delete();

            $invoice->delete();
        }

        foreach( $job->proposals as $proposal )
        {
        	$proposal->materials()->delete();
        	$proposal->labour()->delete();

        	$proposal->delete();
        }

        $job->materials()->delete();
        $job->labour()->delete();

        $job->delete();

		Session::flash("success", "Successfully deleted Job.");

		return redirect( route('jobs.index') );
	}

	/**
	 * Create a non-matching job number
	 * Job numbers work like so:
	 * YY-SEQUE
	 *  2 digit year
	 *  Sequential numbers, five digits
	 * 
	 * @param $number, for recursion purposes
	*/
	private function createJobNumber( $number = false )
	{
		if ( !$number )
		{
			// dump( 'createJobNumber: no number provided.');
			// get latest job
			$job = Job::orderBy('created_at', 'DESC')
					->first();
			// if a Job has been returned
			if ( count( $job ) )
			{
				// verify the number, and add a one to sequential
				$number = $this->checkNumber( $job->number );
				// dump('createJobNumber: Passed number to checkNumber. Generated: '
					// . $number );
			}
			else // if no Job has been returned
			{
				// create a new number
				$number = $this->generateJobNumber( );
				// dump('createJobNumber: no Job has been returned. Call to generateJobNumber. Generated: ' . $number);
			}
		}
		else // if there is a number fed into createJobNumber
		{
			// check the number, and add a one to sequential
			$number = $this->checkNumber( $number );
			// dump('createJobNumber: A number has been fed, passing to checkNumber. Generated: ' . $number );
		}

		// check if the new numbers are used already
		if ( count( Job::where( 'number', $number )->first() ) )
		{
			// if the new number is used, add a one to sequential
			$number = $this->checkNumber( $number );
			// dump('createJobNumber: found a Job with new number being used. Call to checkNumber. Generated: ' . $number, 'Recusion to check new number.' );

			// run the number through this function again
			return $this->createJobNumber( $number );
		}

		// dump('createJobNumber: Final return. number variable has: ' . $number );
		return $number;

	}

	private function generateJobNumber( )
	{

		return date('y')
				.'-'
				.'00000';
	}

	private function checkNumber( $number )
	{
		/**
		 * Roll numbers work like so:
		 * YY-SEQUE
		 *  Sequential numbers, 5 digits
		 */

		$numberArray = explode('-', $number);

		// Ensure we have a valid number
		if ( isset( $numberArray[1] ) )
		{
			// If the number is for this year and month and roll size, do this
			if ( $numberArray[0] == date('y') )
			{
				// dump('Numbers for year match.');
				// Add a number to the sequential digit
				$numberArray[1]++;
				// dump('Added a one to sequential digit.');
				// Create the necessary padding
				$numberArray[1] = str_pad($numberArray[1], 5, '0', STR_PAD_LEFT);
				// dump('Padded the number after addition.');
				// put the number back together again
				$number = implode('-', $numberArray);
				// dump('Imploded number:' . $number );
			}
			else // If the number is not for this year and month, make one
			{
				// dump('Numbers for year, month and width do not match; call to generateJobNumber');
				// ooh aah creating a new number
				$number = $this->generateJobNumber( );
				// dump('Number generated by generateJobNumber: ' . $number );
			}

			// return the new number
			return $number;
			// dump('Generated number, returned by function: ' . $number);
		}
		// If the number is not correct, return back false
		// dump('The number does not appear to be valid because numberArray[4] is not set.');
		return false;
	}
}

resources/views/jobs/create.blade.php
@extends('layouts.admin')

@section('page-title', 'Create Job')

@section('page-head')
<link rel="stylesheet" type="text/css" href="{{ url('/css/bootstrap-datepicker.standalone.min.css') }}">
@stop

@section('page-breadcrumbs')
	<ol class="breadcrumb my-2">
		<li class="breadcrumb-item"><a href="{{ route('home') }}">Admin Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('jobs.index') }}">Jobs</a></li>
		<li class="breadcrumb-item active">New Job</li>
	</ol>
@endsection

@section('page-content')
	<form 	action="{{ route('jobs.store') }}"
			method="POST"
			enctype="multipart/form-data">
		{{ csrf_field() }}
		<div class="form-group">
			<label for="jobDeadline">
				Deadline
			</label>
			<input 	type="date"
					name="deadline"
					id="jobDeadline"
					autocomplete="off"
					class="form-control"
					min="{{ date('Y-m-d', time() - 60 * 60 * 24) }}">
			<small class="form-text {{ $errors->has('name') ? 'invalid-feedback' :'' }}">
				Optional.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobName">
				Client Name
			</label>
			<input 	type="text"
					name="name" 
					class="form-control {{ $errors->has('name') ? 'is-invalid' :'' }}"
					id="jobName"
					value="{{ old('name') }}"
					autocomplete="off">
			<small class="form-text {{ $errors->has('name') ? 'invalid-feedback' :'' }}">
				Optional. Between 2 to 50 characters.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobAddress"
					{{ $errors->has('address') ? 'text-danger' :'' }}>
				Address
			</label>
			<textarea
					name="address"
					class="form-control {{ $errors->has('address') ? 'is-invalid' :'' }}"
					id="jobAddress"
					autocomplete="off"
					required>{{ old('address') }}</textarea>
			<small class="form-text {{ $errors->has('address') ? 'invalid-feedback' :'' }}">
				Required.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobEmail" 
					{{ $errors->has('email') ? 'text-danger' :'' }}>
				Email
			</label>
			<input 	type="email"
					name="email"
					class="form-control {{ $errors->has('email') ? 'is-invalid' :'' }}"
					id="jobEmail"
					value="{{ old('email') }}"
					autocomplete="off">
			<small class="form-text {{ $errors->has('email') ? 'invalid-feedback' :'' }}">
				Optional.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobPhone" 
					{{ $errors->has('phone') ? 'text-danger' :'' }}>
				Phone
			</label>
			<input 	type="text"
					name="phone"
					class="form-control {{ $errors->has('phone') ? 'is-invalid' :'' }}"
					id="jobPhone"
					value="{{ old('phone') }}"
					autocomplete="off">
			<small class="form-text {{ $errors->has('phone') ? 'invalid-feedback' :'' }}">
				Optional. Between 10-15 characters.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobExtension" 
					{{ $errors->has('extension') ? 'text-danger' :'' }}>
				Extension
			</label>
			<input 	type="text"
					name="extension"
					class="form-control {{ $errors->has('extension') ? 'is-invalid' :'' }}"
					id="jobExtension"
					value="{{ old('extension') }}"
					autocomplete="off">
			<small class="form-text {{ $errors->has('extension') ? 'invalid-feedback' :'' }}">
				Optional.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobNote" 
					{{ $errors->has('note') ? 'text-danger' :'' }}>
				Note
			</label>
			<textarea
					name="note"
					class="form-control {{ $errors->has('note') ? 'is-invalid' :'' }}"
					id="jobNote"
					autocomplete="off">{{ old('note') }}</textarea>
			<small class="form-text {{ $errors->has('note') ? 'invalid-feedback' :'' }}">
				Optional. From zero, then 2 characters to more.
			</small>
		</div>

		<button class="btn btn-primary" type="submit">Save New</button>
		<a class="btn btn-outline-primary" href="{{ route('jobs.index') }}#jobActual">
			Cancel
		</a>
	</form>
@stop

@section('page-script')
<script type="text/javascript" src="{{ url('/js/bootstrap-datepicker.min.js') }}"></script>
<script type="text/javascript">
	$( function() {
		var deadlineTestText = 'Testing Date';

		$('#jobDeadline').val( deadlineTestText );

		if( deadlineTestText === $('#jobDeadline').val() )
		{
			$('#jobDeadline').datepicker();
		}
		else
		{
			console.log('The above warning is expected; it is caused by a test to see if the date field is supported by your browser.');
		}

		$('#jobDeadline').val( '{{ old('deadline') }}' );

	} );
</script>

@stop

resources/views/jobs/edit.blade.php
@extends('layouts.admin')

@section('page-title', 'Edit Job')

@section('page-head')
<link rel="stylesheet" type="text/css" href="{{ url('/css/bootstrap-datepicker.standalone.min.css') }}">
@stop

@section('page-breadcrumbs')
	<ol class="breadcrumb my-2">
		<li class="breadcrumb-item"><a href="{{ route('home') }}">Admin Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('jobs.index') }}">Jobs</a></li>
		<li class="breadcrumb-item active">Edit Job</li>
	</ol>
@endsection

@section('page-content')
	<form 	action="{{ route('jobs.update', $job->id) }}"
			method="POST"
			enctype="multipart/form-data">
		{{ csrf_field() }}
		{{ method_field( 'PATCH' ) }}
		<div class="form-group">
			<label for="jobDeadline">
				Deadline
			</label>
			<input 	type="date"
					name="deadline"
					id="jobDeadline"
					autocomplete="off"
					class="form-control">
			<small class="form-text {{ $errors->has('name') ? 'invalid-feedback' :'' }}">
				Optional.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobName" 
					{{ $errors->has('name') ? 'text-danger' :'' }}>
				Client Name
			</label>
			<input 	type="text"
					name="name" 
					class="form-control {{ $errors->has('name') ? 'is-invalid' :'' }}"
					id="jobName"
					value="{{ old('name', $job->name) }}"
					autocomplete="off">
			<small class="form-text {{ $errors->has('name') ? 'invalid-feedback' :'' }}">
				Optional. Between 2 to 50 characters.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobEmail" 
					{{ $errors->has('email') ? 'text-danger' :'' }}>
				Email
			</label>
			<input 	type="email"
					name="email"
					class="form-control {{ $errors->has('email') ? 'is-invalid' :'' }}"
					id="jobEmail"
					value="{{ old('email', $job->email) }}"
					autocomplete="off">
			<small class="form-text {{ $errors->has('email') ? 'invalid-feedback' :'' }}">
				Optional.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobAddress" 
					{{ $errors->has('address') ? 'text-danger' :'' }}>
				Address
			</label>
			<textarea
					name="address"
					class="form-control {{ $errors->has('address') ? 'is-invalid' :'' }}"
					id="jobAddress"
					autocomplete="off"
					required>{{ old('address', $job->address) }}</textarea>
			<small class="form-text {{ $errors->has('address') ? 'invalid-feedback' :'' }}">
				Required.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobPhone" 
					{{ $errors->has('phone') ? 'text-danger' :'' }}>
				Phone
			</label>
			<input 	type="text"
					name="phone"
					class="form-control {{ $errors->has('phone') ? 'is-invalid' :'' }}"
					id="jobPhone"
					value="{{ old('phone', $job->formatPhoneNumber( $job->phone )) }}"
					autocomplete="off">
			<small class="form-text {{ $errors->has('phone') ? 'invalid-feedback' :'' }}">
				Optional. Between 10-15 characters.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobExtension" 
					{{ $errors->has('extension') ? 'text-danger' :'' }}>
				Extension
			</label>
			<input 	type="text"
					name="extension"
					class="form-control {{ $errors->has('extension') ? 'is-invalid' :'' }}"
					id="jobExtension"
					value="{{ old('extension', $job->extension) }}"
					autocomplete="off">
			<small class="form-text {{ $errors->has('extension') ? 'invalid-feedback' :'' }}">
				Optional.
			</small>
		</div>

		<div class="form-group">
			<label 	for="jobNote" 
					{{ $errors->has('note') ? 'text-danger' :'' }}>
				Note
			</label>
			<textarea
					name="note"
					class="form-control {{ $errors->has('note') ? 'is-invalid' :'' }}"
					id="jobNote"
					autocomplete="off">{{ old('note', $job->note) }}</textarea>
			<small class="form-text {{ $errors->has('note') ? 'invalid-feedback' :'' }}">
				Optional. From zero, then 2 characters to more.
			</small>
		</div>

		<button class="btn btn-primary" type="submit">Update</button>
		<a class="btn btn-outline-primary" href="{{ route('jobs.index') }}#jobActual">
			Cancel
		</a>
	</form>
@stop

@section('page-script')
<script type="text/javascript" src="{{ url('/js/bootstrap-datepicker.min.js') }}"></script>
<script type="text/javascript">
	$( function() {
		var deadlineTestText = 'Testing Date';

		$('#jobDeadline').val( deadlineTestText );

		if( deadlineTestText === $('#jobDeadline').val() )
		{
			$('#jobDeadline').datepicker({
					format: 'dd/mm/yyyy',
			});
		}
		else
		{
			console.log('The above warning is expected; it is caused by a test to see if the date field is supported by your browser.');
		}

		$('#jobDeadline').val( '{{ old('deadline', ( $job->deadline !== null ) ? date( 'Y-m-d', strtotime( $job->deadline ) ) : '' ) }}' )

	} );
</script>

@stop